"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var axios_1 = __importDefault(require("axios"));
var prompts_1 = __importDefault(require("prompts"));
var console_1 = __importDefault(require("./console"));
var configs_json_1 = require("../configs/configs.json");
var checkUser = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve) {
                db.find({ selected: true }, function (err, result) { return __awaiter(void 0, void 0, void 0, function () {
                    var _a, accessToken, accessTokenSecret, userid;
                    return __generator(this, function (_b) {
                        if (!err) {
                            _a = result.slice(-1)[0] // 変更
                            , accessToken = _a.accessToken, accessTokenSecret = _a.accessTokenSecret, userid = _a.userid;
                            if (accessToken && accessTokenSecret && userid) {
                                resolve({ accessToken: accessToken, accessTokenSecret: accessTokenSecret, userid: userid });
                            }
                            return [2 /*return*/];
                        }
                        throw new Error('アカウントが見つからないようです...もう一度ログインを試してみてください');
                    });
                }); });
            })];
    });
}); };
var viewListTimeline = function (data) {
    data.forEach(function (item) {
        console.log(item.name + " " + console_1["default"].blue(item.id) + "\n" + item.text + "\n");
    });
};
var getLists = function (accessToken, accessTokenSecret, userid) { return __awaiter(void 0, void 0, void 0, function () {
    var data, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, axios_1["default"].post(configs_json_1.middlewareUrl + "/getList", {
                        access_token: accessToken,
                        access_token_secret: accessTokenSecret,
                        options: {
                            userid: userid
                        }
                    })];
            case 1:
                data = (_a.sent()).data;
                return [2 /*return*/, data];
            case 2:
                err_1 = _a.sent();
                throw new Error('Twitter APIに問題があるようです・・・時間を空けてからもう一度試してみてください。');
            case 3: return [2 /*return*/];
        }
    });
}); };
var selectedList = function (lists) { return __awaiter(void 0, void 0, void 0, function () {
    var selected_1, onCancel, selectedListId, err_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 3, , 4]);
                selected_1 = [];
                return [4 /*yield*/, lists.forEach(function (list) {
                        var shap = {
                            title: list.name + " " + list.description,
                            value: list.id
                        };
                        selected_1.push(shap);
                    })];
            case 1:
                _a.sent();
                onCancel = function () {
                    console.error('Error: 選択されませんでした');
                };
                return [4 /*yield*/, prompts_1["default"]([
                        {
                            type: 'select',
                            name: 'selectedListId',
                            message: '取得したいリストを選択してください',
                            choices: selected_1
                        }
                    ], { onCancel: onCancel })];
            case 2:
                selectedListId = (_a.sent()).selectedListId;
                return [2 /*return*/, selectedListId];
            case 3:
                err_2 = _a.sent();
                throw new Error('Error: 選択されませんでした');
            case 4: return [2 /*return*/];
        }
    });
}); };
var getList = function (accessToken, accessTokenSecret, options) { return __awaiter(void 0, void 0, void 0, function () {
    var data, err_3;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 3, , 4]);
                return [4 /*yield*/, axios_1["default"].post(configs_json_1.middlewareUrl + "/getList", {
                        access_token: accessToken,
                        access_token_secret: accessTokenSecret,
                        options: options
                    })];
            case 1:
                data = (_a.sent()).data;
                return [4 /*yield*/, viewListTimeline(data)];
            case 2:
                _a.sent();
                return [2 /*return*/, true];
            case 3:
                err_3 = _a.sent();
                throw new Error(err_3.message);
            case 4: return [2 /*return*/];
        }
    });
}); };
var list = function (db, data) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, accessToken, accessTokenSecret, userid, listid, lists, selectedListId, err_4;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 7, , 8]);
                return [4 /*yield*/, checkUser(db)];
            case 1:
                _a = _b.sent(), accessToken = _a.accessToken, accessTokenSecret = _a.accessTokenSecret, userid = _a.userid;
                if (!Object.keys(data).length) return [3 /*break*/, 3];
                listid = data.listid;
                return [4 /*yield*/, getList(accessToken, accessTokenSecret, {
                        listid: listid
                    })];
            case 2:
                _b.sent();
                return [2 /*return*/];
            case 3: return [4 /*yield*/, getLists(accessToken, accessTokenSecret, userid)];
            case 4:
                lists = _b.sent();
                return [4 /*yield*/, selectedList(lists)];
            case 5:
                selectedListId = _b.sent();
                return [4 /*yield*/, getList(accessToken, accessTokenSecret, {
                        listid: selectedListId
                    })];
            case 6:
                _b.sent();
                return [2 /*return*/];
            case 7:
                err_4 = _b.sent();
                console.error(err_4.message);
                return [3 /*break*/, 8];
            case 8: return [2 /*return*/];
        }
    });
}); };
exports["default"] = list;
