"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var prompts_1 = __importDefault(require("prompts"));
var console_1 = __importDefault(require("./console"));
var unSelectDb = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var data;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve) {
                    db.update({
                        selected: true
                    }, {
                        $set: {
                            selected: false
                        }
                    }, {
                        multi: true
                    }, function (error) {
                        if (!error) {
                            resolve(true);
                            return;
                        }
                        throw new Error('database削除時にエラーがあったようです...もう一度ログインを試してみてください');
                    });
                })];
            case 1:
                data = _a.sent();
                return [4 /*yield*/, db.loadDatabase()];
            case 2:
                _a.sent();
                return [2 /*return*/, data];
        }
    });
}); };
var setUser = function (db, userName) { return __awaiter(void 0, void 0, void 0, function () {
    var completed;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, unSelectDb(db)];
            case 1:
                if (!_a.sent()) return [3 /*break*/, 5];
                return [4 /*yield*/, new Promise(function (resolve) {
                        db.update({
                            name: userName
                        }, {
                            $set: {
                                selected: true
                            }
                        }, {}, function (error) {
                            if (!error) {
                                resolve(true);
                                return;
                            }
                            throw new Error('database削除時にエラーがあったようです...もう一度ログインを試してみてください');
                        });
                    })];
            case 2:
                completed = _a.sent();
                if (!completed) return [3 /*break*/, 4];
                return [4 /*yield*/, db.loadDatabase()];
            case 3:
                _a.sent();
                console.log(console_1["default"].green('>') + " " + userName + " \u306B\u30A2\u30AB\u30A6\u30F3\u30C8\u3092\u5909\u66F4\u3057\u307E\u3057\u305F");
                return [2 /*return*/];
            case 4: throw new Error('database登録時にエラーがあったようです...もう一度ログインを試してみてください');
            case 5: return [2 /*return*/];
        }
    });
}); };
var findUsers = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var selectedUser;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve) {
                    db.find({}, function (err, result) {
                        if (!err) {
                            var selectArray = [];
                            for (var i = 0; i < result.length; i += 1) {
                                selectArray.push({
                                    title: result[i].name,
                                    value: {
                                        type: 'user',
                                        id: result[i]._id,
                                        name: result[i].name
                                    }
                                });
                            }
                            resolve(selectArray);
                            return;
                        }
                        throw new Error('database検索時にエラーがあったようです...もう一度試してみてください');
                    });
                })];
            case 1:
                selectedUser = _a.sent();
                return [2 /*return*/, selectedUser];
        }
    });
}); };
var selectedChangeUser = function (selected) { return __awaiter(void 0, void 0, void 0, function () {
    var onCancel, user_1, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                onCancel = function () {
                    throw new Error('Error: 選択されませんでした');
                };
                return [4 /*yield*/, prompts_1["default"]([
                        {
                            type: 'select',
                            name: 'user',
                            message: '変更したいアカウントを選択してください',
                            choices: selected
                        }
                    ], { onCancel: onCancel })];
            case 1:
                user_1 = (_a.sent()).user;
                return [2 /*return*/, user_1];
            case 2:
                err_1 = _a.sent();
                throw new Error(err_1);
            case 3: return [2 /*return*/];
        }
    });
}); };
var selectUser = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var selectedArray, name;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, findUsers(db)];
            case 1:
                selectedArray = _a.sent();
                return [4 /*yield*/, selectedChangeUser(selectedArray)];
            case 2:
                name = (_a.sent()).name;
                if (!name) return [3 /*break*/, 4];
                return [4 /*yield*/, setUser(db, name)];
            case 3:
                _a.sent();
                _a.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); };
var checkUserName = function (db, userName) { return __awaiter(void 0, void 0, void 0, function () {
    var selected;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve) {
                    db.findOne({ name: userName }, function (error, result) {
                        if (!error) {
                            resolve(result);
                            return;
                        }
                        throw new Error('Error: あれ');
                    });
                })];
            case 1:
                selected = _a.sent();
                if (!selected) return [3 /*break*/, 3];
                return [4 /*yield*/, setUser(db, userName)];
            case 2:
                _a.sent();
                return [2 /*return*/];
            case 3:
                selectUser(db);
                return [2 /*return*/];
        }
    });
}); };
var user = function (db, name) {
    try {
        if (name) {
            checkUserName(db, name);
            return;
        }
        selectUser(db);
    }
    catch (err) {
        console.error(err.message);
    }
};
exports["default"] = user;
